# Contributing to VersionOne JavaScript PipelineBuilder Library

 1. [Getting Involved](#getting-involved)
 2. [Reporting Bugs](#reporting-bugs)
 3. [Improving Documentation](#improving-documentation)
 4. [Contributing Code](#contributing-code)

## Getting Involved

We need your help to make the VersionOne JavaScript PipelineBuidler Library a useful tool. While third-party patches are absolutely essential, they are not the only way to get involved. You can help the project by discovering and [reporting bugs](#reporting-bugs), [improving documentation](#improving-documentation), and helping others on [GitHub issues](https://github.com/walkerrandolphsmith/VersionOne.JavaScript.PipelineBuilder/issues).

## Reporting Bugs

Before reporting a bug on the project's [issues page](https://github.com/walkerrandolphsmith/VersionOne.JavaScript.PipelineBuilder/issues), first make sure that your issue is caused by the Library, not your application code (e.g. passing incorrect arguments to methods, etc.). Second, search the already reported issues for similar cases, and if it has been reported already, just add any additional details in the comments.

After you made sure that you have found a new bug, here are some tips for creating a helpful report that will make fixing it much easier and quicker:

 * Write a **descriptive, specific title**. Bad: *Promblem with Jenkins Plugin*. Good: *Jenkins get_build_plugin returns an empty object*.
 * Whenever possible, include **Function** info in the description.
 * Create a **simple test case** that demonstrates the bug.

## Improving Documentation

All documentation and examples are located in the project's [wiki](https://github.com/walkerrandolphsmith/VersionOne.JavaScript.PipelineBuilder/wiki).
Community driven documentation improvement is a pending feature.

## Contributing Code

### Making Changes to Source

If you are not yet familiar with the way GitHub works (forking, pull requests, etc.), be sure to read [the article about forking](https://help.github.com/articles/fork-a-repo) on the GitHub Help website &mdash; it will get you started quickly.

You should always write each batch of changes (feature, bugfix, etc.) in **its own topic branch**. Please do not commit to the `master` branch, or your unrelated changes will go into the same pull request.

You should also follow the code style and whitespace conventions of the original codebase.

### Considerations for Accepting Patches

Before sending a pull request with a new feature, first check if it has been discussed before already (either on [GitHub issues](https://github.com/walkerrandolphsmith/VersionOne.JavaScript.PipelineBuilder/wiki). If your feature or API improvement did get merged into master, please consider submitting another pull request with the corresponding [documentation update](#improving-documentation).

### Open Source Licenses and Attribution
Regardless of whether attribution is required by included code or a dependency, we want to acknowledge the work that VersionOne.JavaScript.PipelineBuilder depends on and make it easy for people to evaluate the legal implications of using this library. Therefore, all dependencies should be attributed in the ACKNOWLEDGEMENTS.md. This should include the persons or organizations who contributed the libraries, a link to the source code, and a link to the underlying license.