export declare const constants: {
    ALWAYS: "always";
    CONDITIONALLY: "conditionally";
    NEVER: "never";
    GET: "get";
    POST: "post";
    PUT: "put";
    DELETE: "delete";
    PATCH: "patch";
    SUCCESS: "end-success";
    FAILURE: "end-failure";
    CANCELED: "end-canceled";
};
export declare const plugins: {
    automate: {
        run_task: (task: any, version: any, initial_data: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    bamboo: {
        build: (build_id: any, revision: any, parameters: any, wait: string, inherit_build_status: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    bitbucket: {
        api_call: (type: string, request: any, data: {}, response_key: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        create_branch: (project: any, repository: any, source_branch: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        delete_branch: (project: any, repository: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        show_summary: (when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    canvas: {
        get: (key: any, resource: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        interact: (resource: any, tags: any[], when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        } & {
            tags: any;
        };
        show: (resource: any, label: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    deploy: {
        deploy_application: (template: any, version: any, data_store: {}, sequence_data: {}, params: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        run_sequence: (sequence: any, deployment: any, sequence_data: any, params: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        terminate: (when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    flow: {
        artifact: {
            load_revision: (project: any, artifact_name: any, revision: any, workspace_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            new_revision: (project: any, artifact_name: any, branch: any, location: any, version: any, build_id: any, build_url: any, build_details: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            update_revision: (project: any, artifact_name: any, branch: any, location: any, version: any, build_id: any, build_url: any, build_details: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
        group: {
            set_global: (key: any, value: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
        interact: {
            action: (asssign_to: any[], definition: any, tags: any[], when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            } & {
                tags: any;
            };
            confirmation: (title: any, text: any, asssign_to: any[], tags: any[], when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            } & {
                tags: any;
            };
        };
        manifest: {
            copy_to_workspace: (workspace_key: any, include: any, verbose: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            evaluate_changes: (expression: any, key: any, count: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            evaluate_workitems: (expression: any, key: any, count: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
        pipeline: {
            initiate: (defintion: any, project: any, group: any, start_now: boolean, initial_data: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            set_data: (key: any, value: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            set_description: (value: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            set_global_summary_data: (pipeline: any, key: any, value: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            set_name: (name: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
        pkg: {
            deliver_revision: (package_name: any, revision: any, full_version: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            get_artifact: (package_name: any, revision: any, artifact_name: any, artifact_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            get_artifacts: (package_name: any, revision: any, artifact_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            get_globals: (package_name: any, revision: any, globals_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            load_revision: (package_name: any, revision: any, globals_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            new_revision: (package_name: any, version: any, full_version: any, globals_key: any, workspace_key: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            promote_revision: (package_name: any, revision: any, full_version: any, phase: any, new_version: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
            set_global: (package_name: any, revision: any, key: any, value: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
        project: {
            new_version: (to_version: any, increment: any, when: any, additional_args: any, description: any) => {
                plugin: any;
                name: string;
                when: string;
            };
        };
    };
    github: {
        api_call: (type: string, url: any, data: {}, response_key: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        create_branch: (repository: any, source_branch: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        delete_branch: (repository: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_file: (repository: any, branch: any, path: any, response_key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_issue: (issue_number: any, repository: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        list_repositories: (instance_name: any, response_key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        show_summary: (when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        wait_for_pr_mergeability: (repository: any, pr_number: any, response_key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    gitlab: {
        api_call: (type: string, request: any, data: {}, response_key: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        create_branch: (project: any, reference: any, branch_name: any, failifexists: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        delete_branch: (project: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        list_repositories: (instance_name: any, response_key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        show_summary: (when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    hipchat: {
        send_notification: (message: any, room: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    jenkins: {
        build: (job_name: any, parameters: {}, wait: any, inherit_job_status: any, regular_expression: any, artifact_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_build_info: (job_name: any, build_number: any, wait: any, inherit_job_status: any, regular_expression: any, artifact_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        read_workspace_file: (job: any, path: any, target: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_url: (path: any, target: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    jira: {
        add_link_to_issue: (issue_id: any, title: any, url: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        add_comment_to_issue: (issue_id: any, comment: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        transition_issues: (transition_name: any, resolution_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    octopus: {
        deploy: (environment_name: any, project: any, release: any, additional: any, wait: any, inherit_build_status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    ossum: {
        cast_vote: (score: any, change_number: any, patchset_number: any, message: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    skytap: {
        create_environment: (template_id: any, start: string, account_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        delete_environment: (environment_id: any, account_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    slack: {
        post_message: (channel: any, message: any, attachments: any, as_user: any, fail_on_error: string, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    teamcity: {
        build: (build_id: any, parameters: {}, branch_name: any, commit_id: any, snapshot_id: any, vcs_instance_id: any, time_out: any, wait: any, inherit_build_status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_build_info: (build_number: any, wait: any, inherit_build_status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    tfs: {
        create_branch: (project: any, repository: any, source_branch: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        delete_branch: (project: any, repository: any, branch_name: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    utility: {
        conditional: (expression: any, if_block: any, else_block: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        email_contributors: (cc: any, subject: any, body: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_registry: (key: any, name: any, required: boolean, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_registry: (name: any, path_to_set: any, value: any, create: boolean, action: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        wait_for_data: (expression: any, status: any, wait_seconds: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        junit_results: (key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        show_workspace_data: (key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        apply_label: (label_name: any, path_in_doc: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        loop: (action: any, iterator: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        end: (status: string, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        http: (url: any, headers: any, http_verb: string, data: any, key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        log: (message: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        sleep: (seconds: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        parse_data: (source: any, expression: any, target: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_next_id: (name: any, key: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        find_in_array: (array: any, expression: any, target: any, match_index: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        python_script: (code: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        add_manifest: (name: any, key: any, create: boolean, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_globals: (name: any, key: any, required: boolean, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_global: (name: any, key: any, value: any, create: boolean, required: boolean, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        load: (name: any, key: any, required: boolean, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
    v1: {
        check_all_systems_go: (key: any, should_continue: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        check_blocking_issues: (key: any, should_continue: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        check_epic_completeness: (key: any, should_continue: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        check_workitem_dependencies: (key: any, should_continue: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        create_pipeline_run: (build_project: any, name: any, reference: any, initial_status: string, target_key: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        custom_query: (query: any, key: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_pipeline_run_status: (build_run_oid: any, new_status: any, set_workitems_as_complete: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        push_link: (oid: any, linkurl: any, linkname: any, onmenu: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        push_link_to_all_workitems: (linkurl: any, linkname: any, on_menu: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_all_workitem_statuses: (status: any, current_status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_attributes_on_all_workitems: (attributes: string, skip_if_closed: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_epic_status: (number: any, status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        get_epic_workitems: (number: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_workitem_attributes: (workitem_number: any, attributes: string, skip_if_closed: string, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        set_workitem_status: (number: any, status: any, current_status: any, instance_name: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
        specify_phase: (phase: any, package_name: any, package_label: any, revision: any, full_version: any, instance_name: any, is_required: any, when: any, additional_args: any, description: any) => {
            plugin: any;
            name: string;
            when: string;
        };
    };
};
export declare const create_reference: (key: any) => string;
export declare const create_stage: (name?: string, steps?: any[]) => {
    name: string;
    steps: any[];
};
export declare const create_phase: (name?: string, stages?: any[]) => {
    name: string;
    stages: any[];
};
export declare const create_pipeline: (name?: string, description?: string, phases?: any[], team?: string, category?: string, globals?: {}) => {
    name: string;
    description: string;
    team: string;
    category: string;
    globals: {};
    phases: any[];
    actions: string;
    dependencies: any[];
    interactive: boolean;
    pipelineglobals: {};
    summary: any[];
};
