"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var automate_1 = require("./plugins/automate");
var bamboo_1 = require("./plugins/bamboo");
var bitbucket_1 = require("./plugins/bitbucket");
var canvas_1 = require("./plugins/canvas");
var deploy_1 = require("./plugins/deploy");
var flow_1 = require("./plugins/flow");
var github_1 = require("./plugins/github");
var gitlab_1 = require("./plugins/gitlab");
var hipchat_1 = require("./plugins/hipchat");
var jenkins_1 = require("./plugins/jenkins");
var jira_1 = require("./plugins/jira");
var octopus_1 = require("./plugins/octopus");
var ossum_1 = require("./plugins/ossum");
var skytap_1 = require("./plugins/skytap");
var slack_1 = require("./plugins/slack");
var teamcity_1 = require("./plugins/teamcity");
var tfs_1 = require("./plugins/tfs");
var utility_1 = require("./plugins/utility");
var v1_1 = require("./plugins/v1");
var cts = require("./plugins/constants");
exports.constants = __assign({}, cts);
exports.plugins = {
    automate: automate_1.automate,
    bamboo: bamboo_1.bamboo,
    bitbucket: bitbucket_1.bitbucket,
    canvas: canvas_1.canvas,
    deploy: deploy_1.deploy,
    flow: flow_1.flow,
    github: github_1.github,
    gitlab: gitlab_1.gitlab,
    hipchat: hipchat_1.hipchat,
    jenkins: jenkins_1.jenkins,
    jira: jira_1.jira,
    octopus: octopus_1.octopus,
    ossum: ossum_1.ossum,
    skytap: skytap_1.skytap,
    slack: slack_1.slack,
    teamcity: teamcity_1.teamcity,
    tfs: tfs_1.tfs,
    utility: utility_1.utility,
    v1: v1_1.v1
};
exports.create_reference = function (key) { return "[$ " + key + " $]"; };
exports.create_stage = function (name, steps) {
    if (name === void 0) { name = ''; }
    if (steps === void 0) { steps = []; }
    return ({ name: name, steps: steps });
};
exports.create_phase = function (name, stages) {
    if (name === void 0) { name = ''; }
    if (stages === void 0) { stages = []; }
    return ({ name: name, stages: stages });
};
exports.create_pipeline = function (name, description, phases, team, category, globals) {
    if (name === void 0) { name = ''; }
    if (description === void 0) { description = ''; }
    if (phases === void 0) { phases = []; }
    if (team === void 0) { team = 'Default'; }
    if (category === void 0) { category = ''; }
    if (globals === void 0) { globals = {}; }
    return ({
        name: name,
        description: description,
        team: team,
        category: category,
        globals: globals,
        phases: phases,
        actions: '',
        dependencies: [],
        interactive: false,
        pipelineglobals: {},
        summary: []
    });
};
//# sourceMappingURL=index.js.map